#using_animtree("generic_human");
main()
{
	precacheShellshock("default");
	setcvar("introscreen","1");

	precacheing();

	maps\_load::main();
	maps\_sherman_gmi::main();
	maps\_panzeriv_gmi::main();

	level.player takeallweapons();
	level.player giveWeapon("springfield");
	level.player giveWeapon("thompson");
	level.player giveWeapon("colt");
	level.player giveWeapon("fraggrenade");
	level.player switchToWeapon("springfield");

	//level.player.health = 35000;	//for testing only!

	squadcontrol();
	thread Sherman();
	thread Panzer();
	thread mapfx();
	obj1();
}

precacheing()
{
	precachemodel("xmodel/mp_vehicle_sherman");
	precachemodel("xmodel/mp_vehicle_panzeriv");
	level._effect["planefire"] = loadfx("fx/fire/pathfinder_extreme.efx");
	level._effect["planesmoke"] = loadfx("fx/smoke/largethick2.efx");
	level._effect["tanksmoke"] = loadfx("fx/smoke/smoke_plume_debree.efx");
}

mapfx()
{
	planefx = getent("planecrash","targetname");
	maps\mp\_fx::loopfx("planefire", planefx.origin + (0,0,10), 0.5);
	maps\mp\_fx::loopfx("planesmoke", planefx.origin, 0.5);
	planefx PlayLoopSound("planefire_high");

	tankfx = getent("tanksmoke","targetname");
	maps\mp\_fx::loopfx("tanksmoke", tankfx.origin, 0.7);
}

obj1()
{
	obj1 = getent("obj1", "targetname");						//Get entity(trigger_use) in map
	objradio = getent("radio", "targetname");
	objective_add(1, "active", &"VILLE_DE_SANG_OBJ1",objradio.origin);
	objective_current(1);
	iprintlnbold (&"VILLE_DE_SANG_OBJ1"); 						//Display objective in obj. list from string

	obj1 waittill("trigger"); 							//Waits till trigger_use is triggered
	objective_state(1, "done"); 							//Objective 1 is complete

	objradio playsound ("bodyfall_dirt_large");

	iprintlnbold ("Radio has been shut down. Reinforcements have been cut off!");
	iprintlnbold (" ");

	wait 2;
	thread obj2(); 									//Move on to next objective
}

obj2()
{
	obj2 = getent("obj2", "targetname"); 						//Get entity(German officer) in map
	objective_add(2, "active", &"VILLE_DE_SANG_OBJ2",obj2.origin);
	objective_current(2);
	iprintlnbold (&"VILLE_DE_SANG_OBJ2");
	iprintlnbold (" ");

	obj2 waittill("death"); 							//Waits till German officer is killed
	objective_state(2, "done"); 							//Objective 2 is done

	iprintlnbold (&"VILLE_DE_SANG_ALLOBJ_COMPLETED"); 				//Let player know they completed all objectives
	iprintlnbold (" ");

	wait(2);
	iprintlnbold ("Terminate all remaining enemy troops!");
}

squadcontrol()
{
	squad = getentarray("squadmate", "script_noteworthy");

	for(i = 0; i < squad.size; i++)
	{
		squad[i] thread follow_player();
	}
}

follow_player()
{
	while(isAlive(self))
	{
		self.health = level.player.health + 20;
		self setgoalpos(level.player.origin);
		self.goalradius = 512;
		wait (1);
	}
	
}

Panzer()
{
	panzer = getent ("panzer","targetname");
	panzer thread maps\_panzeriv_gmi::init();
	panzer thread maps\_tankgun_gmi::mgoff();
	panzer.health = 7500;

	panzer thread shootSherman();
}

shootSherman()
{
	target = getent("sherman","targetname");
	self setTurretTargetEnt(target, (0, 0, 0));
	wait 40;

	while(isAlive(target))
	{
		self waittill( "turret_on_vistarget" );
		wait 5;
		self FireTurret();
	}

	if(self.health > 0)
	{
		target = level.player;

		while(isAlive(target))
		{
			self setTurretTargetEnt(target, (0, 0, 0));
			self waittill( "turret_on_vistarget" );
			wait 12;
			self FireTurret();
		}
	}
}

Sherman()
{
	sherman = getent ("sherman","targetname");
	sherman thread maps\_sherman_gmi::init();
	sherman thread maps\_tankgun_gmi::mgon();

	if(getCvarInt("scr_killsherman") == 1)
	{
		sherman.health = 4000;
	}
	else
	{
		sherman.health = 10000;
	}

	path1 = getvehiclenode ("shermanpath1","targetname");
	sherman attachPath (path1);
	sherman startPath();
	sherman waittill("reached_end_node");

	target = getent("tankshoot1","targetname");
	sherman setTurretTargetEnt(target, (0, 0, 0));
	sherman waittill("reached_end_node");
	sherman waittill( "turret_on_vistarget" );
	sherman FireTurret();

	target = getent("tankshoot2","targetname");
	sherman setTurretTargetEnt(target, (0, 0, 0));
	wait 3;
	sherman waittill( "turret_on_vistarget" );
	sherman FireTurret();

	target = getent("tankshoot1","targetname");
	sherman setTurretTargetEnt(target, (0, 0, 0));
	wait 3;
	sherman waittill( "turret_on_vistarget" );
	sherman FireTurret();

	target = getent("tankshoot2","targetname");
	sherman setTurretTargetEnt(target, (0, 0, 0));
	wait 3;
	sherman waittill( "turret_on_vistarget" );
	sherman FireTurret();

	path2 = getvehiclenode ("shermanpath2","targetname");
	sherman attachPath (path2);
	sherman startPath();
	sherman thread maps\_tankgun_gmi::mgoff();
	sherman waittill("reached_end_node");

	sherman thread killPanzer();
	sherman waittill("panzer_dead");

	if(isAlive(sherman))
	{
		path3 = getvehiclenode ("shermanpath3","targetname");
		sherman attachPath (path3);
		sherman startPath();

		target = getent("tankshoot3","targetname");
		sherman setTurretTargetEnt(target, (0, 0, 0));
		wait 5;
		sherman waittill( "turret_on_vistarget" );
		sherman FireTurret();

		target = getent("tankshoot4","targetname");
		sherman setTurretTargetEnt(target, (0, 0, 0));
		wait 5;
		sherman waittill( "turret_on_vistarget" );
		sherman FireTurret();

		target = getent("tankshoot3","targetname");
		sherman setTurretTargetEnt(target, (0, 0, 0));
		wait 5;
		sherman waittill( "turret_on_vistarget" );
		sherman FireTurret();

		target = getent("tankshoot4","targetname");
		sherman setTurretTargetEnt(target, (0, 0, 0));
		wait 5;
		sherman waittill( "turret_on_vistarget" );
		sherman FireTurret();

		target = getent("tankshoot5","targetname");
		sherman setTurretTargetEnt(target, (0, 0, 0));
		wait 5;
		sherman waittill( "turret_on_vistarget" );
		sherman FireTurret();

		sherman thread randomtanktargets();
	}
}

killPanzer()
{
	target = getent("panzer","targetname");
	self setTurretTargetEnt(target, (0, 0, 0));

	while(target.health > 0)
	{
		self waittill( "turret_on_vistarget" );
		self FireTurret();
		wait 3;
	}

	self notify("panzer_dead");
}

randomtanktargets()
{
	while(self.health > 0)
	{
		switch(randomint(6))
			{
				case 1:
				target = getent("tankshoot3" ,"targetname");
				break;
				case 2:
				target = getent("tankshoot4" ,"targetname");
				break;
				case 3:
				target = getent("tankshoot5" ,"targetname");
				break;
				case 4:
				target = getent("tankshoot6" ,"targetname");
				break;
				case 5:
				target = getent("tankshoot7" ,"targetname");
				break;
				case 6:
				target = getent("tankshoot8" ,"targetname");
				break;
				default:
				target = getent("tankshoot4" ,"targetname");
				break;
			}

		self setTurretTargetEnt(target, (0, 0, 0));
		wait 5;
		self waittill( "turret_on_vistarget" );

		if(distance(target.origin, level.player.origin) < 256)
		{
			continue;
		}
		else
		{
		self FireTurret();
		}
	}
}